local mod = RW:Boss("Al'Akir", "Throne of the Four Winds")
local L

mod.BossIcon = [[Interface\ICONS\achievement_boss_murmur]]
mod.SupressGlobalHealthFrames = true

---------------------------
-- Variables



---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L["Add Spawn Emote"] = "Storms! I summon you to my side!"
		L["Next Add"] = true
		L["New Add Spawned!"] = true
		L["Adds"] = true
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(46753)
	self:SetWin()	
	
	-- Feedback
	self:RegisterAlert("tFeedbackDur", self:DurStackTimer(20, 87904))
	self:RegisterAlert("mFeedback", self:StackMessage(87904))
	
	-- Adds
	self:RegisterAlert("tAddsCD", self:CDTimer(20, L["Next Add"], [[Interface\Icons\Spell_shaman_thunderstorm]], L["Adds"]))
	self:RegisterAlert("wAdds", self:Warning(L["New Add Spawned!"], [[Interface\Icons\Spell_shaman_thunderstorm]], L["Adds"]))
	
	-- Wind Burst
	self:RegisterAlert("wBurst", self:RunawayWarning(87770))
	self:RegisterAlert("tBurstCD", self:CDTimer(25, 87770))
	self:RegisterAlert("tBurstCast", self:CastTimer(5, 87770))
	
	-- Lightning Rod
	self:RegisterAlert("iRod", self:Icon("SKULL", 89666, false, 5))
	self:RegisterAlert("wRod", self:OnYouWarning(89666))
	self:RegisterAlert("mRod", self:TargetMessage(89666))
	
	-- Acid Rain
	self:RegisterAlert("tRainCD", self:DurStackTimer(20, 93280))
	self:RegisterAlert("mRain", self:StackMessage(93280))
end

---------------------------
-- Locals
local LastAcid = 0

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Feedback", 87904)
	self:Track("WindBurst", 87770, 93261, 93262, 93263)
	self:Track("LightningRod", 89666, 89668)
	self:Track("AcidRain", 93280, 88301, 93279, 93281)
	
	self:YellTrack("Adds", L["Add Spawn Emote"])
	
	RW.Callbacks:Fire("MPBHealthByID", 46753, nil, {80, 30})
	
	LastAcid = 0
end

function mod:Feedback(event, args)
	if event == "SPELL_AURA_APPLIED" then
		self:Call("tFeedbackDur", "Start", nil, args.amount or 1)
		self:Call("mFeedback", "Show", args.amount or 1)
	end
end

function mod:WindBurst(event, args)
	if event == "SPELL_CAST_START" then
		self:Call("tBurstCD", "Schedule", 5, 20)
		self:Call("tBurstCast", "Start")
		self:Call("wBurst", "Show")
	end
end

function mod:LightningRod(event, args)
	if event == "SPELL_AURA_APPLIED" then
		self:Call("iRod", "Show", args.dName)
		
		if args:IsPlayer() then
			self:Call("wRod", "Show")
		else
			self:Call("mRod", "Show", args.dName)
		end
	end
end

function mod:AcidRain(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		if GetTime() - LastAcid > 5 then
			self:Call("mRain", "Show", args.amount or 1)
			self:Call("tRainCD", "Start", nil, (args.amount or 1) + 1)
		end
		LastAcid = GetTime()
	end
end

function mod:Adds(event, msg, name)
	self:Call("tAddsCD", "Start")
	self:Call("wAdds", "Show")
end
